#ifndef _Clock_HINPUT_h__
#define _Clock_HINPUT_h__

#include "TimeSource.h"

#define WIN32_LEAN_AND_MEAN
#include "Windows.h"
#undef WIN32_LEAN_AND_MEAN

namespace HInput 
{

	// Singleton windows only game clock
	class DefaultWin32Clock : public TimeSource
	{
	private:
		DefaultWin32Clock();
		DefaultWin32Clock(const DefaultWin32Clock&); // not implemented
		const DefaultWin32Clock& operator=(const DefaultWin32Clock&); // not implemented

	public:
		~DefaultWin32Clock();

		static DefaultWin32Clock&	GetInstance();

		// We need to call this if we use the default clock
		void		Update();

		// TimeSource implementation
		float		GetTime() const				{ return m_TotalTime; }
		float		GetFrameDuration() const	{ return min(max(m_FrameDuration, 0.0f), 1.0f/30.0f); }
		unsigned	GetFrameNum() const			{ return m_FrameNum; }

	private:
		LARGE_INTEGER	m_LastCount;
		LARGE_INTEGER	m_PerfFreq;
		float			m_FrameDuration;
		float			m_TotalTime;
		unsigned		m_FrameNum;
	};

} // namespace HInput

#endif // _Clock_HINPUT_h__
