// Copyright  2010 Henry Golding
// This file is part of the "HInput" input abstraction layer.
// For conditions of distribution and use, see copyright notice in HInput.h

#ifndef _Enums_h__
#define _Enums_h__

namespace HInput
{
	/*
		An enumeration of all available players. Limited
		to four by default, but could be edited as long 
		as MAX_PLAYERS is left at the end and has a	value 
		of at least 1.
	*/
	enum PlayerID
	{
		Player_One = 0,
		Player_Two,
		Player_Three,
		Player_Four,
		// Insert additional players here if required
		MAX_PLAYERS
	};

	/*
		An enumeration of all the possible ways that
		inputs can be combined.
	*/
	namespace CombinationOperator
	{
		enum COValue
		{
			None = 0,
			And,
			Or
		};
	}

} // end namespace HInput
#endif // _Enums_h__
