// Copyright  2010 Henry Golding
// This file is part of the "HInput" input abstraction layer.
// For conditions of distribution and use, see copyright notice in HInput.h

#ifndef _PluginManager_HINPUT_h__
#define _PluginManager_HINPUT_h__

#include <vector>
#include <string>

namespace HInput
{

	// Fwd dec
	class Plugin;

	/*
		Plugin manager handles finding, loading and unloading 
		input plugins
	*/
	class PluginManager
	{
	public:
		PluginManager();
		~PluginManager();
		
		void LoadPlugins(const std::string& targetDir);
		void Shutdown();

	private:

		void FindFilenames(const std::string& targetDir, std::vector<std::string>& outFilenames) const;
		void Cleanup();

		std::vector<Plugin*> m_PluginPtrs;

	};


} // end namespace HInput

#endif // _PluginManager_HINPUT_h__